struct Deck {
	struct Card* cards;
	int n; //number of cards
	
	int new; //number of new cards
	int inuse; //number of currently used cards
	int old; //number of used cards;
};

struct Card* get_rand_card(struct Deck* d)
{
	int i;
	if (!d->new) {
		assert(d->old); //no deck overrun;
		for (i = 0; i < d->n; ++i) {
			if (d->cards[i].s == CARDOLD) {
				d->cards[i].s = CARDNEW;
				d->new++;
				d->old--;
			}
		}
	}
	i = my_rand(0, d->n - 1);
	while (d->cards[i].s != CARDNEW) if (++i == d->n) i = 0;
	d->cards[i].s = CARDINUSE;
	d->new--;
	d->inuse++;
	return &d->cards[i];
}

void putback_card(struct Card* c, struct Deck* d)
{
	assert(c->s == CARDINUSE);
	c->s = CARDOLD;
	d->inuse--;
	d->old++;
}

struct Deck* make_deck() {
	int col, shp, num, fil;
	int i = 0;
	
	struct Deck* newdeck;
	newdeck = MY_MALLOC(struct Deck,1);
	newdeck->new = newdeck->n = 81;
	newdeck->old = newdeck->inuse = 0;
	
	newdeck->cards = MY_MALLOC(struct Card, newdeck->n);
	
	for (col = 0; col < 3; ++col) {
		for (shp = 0; shp < 3; ++shp) {
			for (num = 0; num < 3; ++num) {
				for (fil = 0; fil < 3; ++fil) {
					struct Card* c = &newdeck->cards[i];
					Property* p;
					c->n = 4;
					p = c->props = MY_MALLOC(Property, c->n);
					c->i = i++;
					p[COL] = col;
					p[SHP] = shp;
					p[NUM] = num;
					p[FIL] = fil;
					c->s = CARDNEW;
					c->inset = 0;

					c->img = card_img(col,shp,num,fil);
				}
			}
		}
	}
	return newdeck;
}

void dump_deck(struct Deck* dek) {
	int i;
	printf("**DECK:%u CARDS**\n", dek->n);
	for (i = 0; i < dek->n; ++i) {
		dump_card(&dek->cards[i]);
	}
	printf("**DECK END**\n");
}

void kill_deck(struct Deck* d)
{
	int i;
	for (i = 0; i < d->n; ++i) {
		free(d->cards[i].props);
		free(d->cards[i].img);
	}
	free(d->cards);
	free(d);
}
