/*
 * ncurses server;)
 * fuksa@v-lo.krakow.pl
 * warning: endianness problems!
 */
#include<ncurses.h>
#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<sys/select.h>
#include<netinet/in.h>
#include<netdb.h>
#include<unistd.h>
#include<pwd.h>
#include<string.h>

#define HZ 100
void my_die(const char* lastwords)
{
	printf("progname: ");
	perror(lastwords);
	exit(1);
}

int my_connect(const char* host, const char* portnum)
{
	struct sockaddr_in adres;
	struct hostent* he;
	int port;
	char* endptr;
	int sockfd;

	port = strtol(portnum, &endptr, 0);
	if (!*portnum || *endptr) my_die("strtol");
	
	adres.sin_family = AF_INET;
	adres.sin_port = htons(port);
	he = gethostbyname(host);
	if (!he) my_die("gethostbyname");
	adres.sin_addr.s_addr = *(int*)he->h_addr;
	
	sockfd = socket(PF_INET, SOCK_STREAM, 0);
	if (sockfd == -1) my_die("socket");

	if(connect(sockfd, (struct sockaddr*)&adres, sizeof(adres)) == -1) my_die("connect");
	return sockfd;
}


void get_nick(char* nick)
{
	struct passwd* pws;
	pws = getpwuid(getuid());
	if (!pws) my_die("You don't exist. Go away!");
	strncpy(nick, pws->pw_name, 8);
}

int main(int argc, char** argv)
{
	int buf[80*24];
	char nick[8] = {' ', ' ', ' ', ' ',    ' ', ' ', ' ', ' '};
	int gniazdko;
	fd_set fds;
	struct timeval tv;
	int retval;
	int received = 0;
	int tosend = ERR;
	int didsth;
	int i;

	tv.tv_sec = 0;
	tv.tv_usec = 0;

	if (argc != 3) {
		my_die("argc!=3");
	}

	gniazdko = my_connect(argv[1], argv[2]);
	get_nick(nick);
	for (i = 8; i; --i) {
		int letter = (int)nick[i-1];
		if (sizeof(letter) != send(gniazdko, &letter, sizeof(letter), 0))
		my_die("send_nick");
	}

	initscr();
	
	start_color();
	init_pair(1,COLOR_RED, COLOR_BLACK);
	init_pair(2,COLOR_GREEN, COLOR_BLACK);
	init_pair(3,COLOR_BLUE, COLOR_BLACK);
	init_pair(4,COLOR_BLACK, COLOR_BLACK);
	
	cbreak();
	nodelay(stdscr, TRUE);
	noecho();
	nonl();
	intrflush(stdscr, FALSE);
	keypad(stdscr, TRUE);
	while(1) {
		/*read*/
		FD_ZERO(&fds);
		FD_SET(gniazdko, &fds);
		retval = select(gniazdko+1, &fds, NULL, NULL, &tv);
		if (retval == -1) my_die("select[read]");
		if (retval) {
			retval = recv(gniazdko, &buf[received], sizeof(buf) - received, 0);
			if (retval == -1) my_die("recv");
			received += retval;
			if (received == sizeof(buf)) {
				int x,y;
				for (y = 0; y < 24; ++y) {
					for (x = 0; x < 80; ++x) {
						int a = y * 80 + x;
						move(y, x);
						addch(buf[a]);
					}
				}
				refresh();
				received = 0;
			}
			didsth = 1;
		}
		/* write */
		if (tosend != ERR) {
			FD_ZERO(&fds);
			FD_SET(gniazdko, &fds);
			retval = select(gniazdko+1, NULL, &fds, NULL, &tv);
			if (retval == -1) my_die("select[write]");
			if (retval) {
				retval = send(gniazdko, &tosend, sizeof(tosend), 0);
				if (retval != sizeof(tosend)) my_die("send");
			}
			tosend = ERR;
			didsth = 1;
		}
		tosend = getch();
		if (tosend != ERR) didsth = 1;
		if (!didsth) usleep(1000000 / HZ);
		didsth = 0;
	}
	endwin();
	return 0;
}
