struct Set {
	struct Card** cards;
	int n;
};
struct Set* make_set()
{
	struct Set* newset = MY_MALLOC(struct Set,1);
	newset->n = 3;
	newset->cards = MY_MALLOC(struct Card*, newset->n);
	return newset;
};
void kill_set(struct Set* s)
{
	free(s->cards);
	free(s);
}

int intcompar(const void *a, const void *b)
{
	return *(int*)a - *(int*)b;
}

bool allthesame(Property* p, int n)
{
	int i;
	for (i = 1; i < n; ++i) if (p[i] != p[i-1]) return false;
	return true;
}

bool alldiffrent(Property* p, int n)
{
	int i;
	for (i = 1; i < n; ++i) if (p[i] == p[i-1]) return false;
	return true;
}

bool good_set(struct Set* set)
{
	int i;
	bool result = true;
	Property* props;
	assert(set->n > 0); //no empty sets;
	props = MY_MALLOC(Property, set->n);
	
	for (i = 0; i < set->cards[0]->n; ++i) {
		int j;
		for (j = 0; j < set->n; ++j) {
			props[j] = set->cards[j]->props[i];
		}
		qsort(props, set->n, sizeof(Property), intcompar);
		if (!allthesame(props,set->n) && !alldiffrent(props,set->n)) {
			result = false;
			break;
		}
	}
	free(props);
	return result;
}
