void my_die(char* lastwords) {
	perror(lastwords);
	exit(1);
}

char* my_strdup(const char* s)
{
	char* p = strdup(s);
	if (!p) my_die("strdup");
	return p;
}
#define MY_MALLOC(typ,ile) (typ*)my_malloc(sizeof(typ)*(ile))
void* my_malloc(unsigned int n) {
	void* p = (void*)malloc(n);
	if (!p) my_die("malloc");
	return p;
}

/* x=rand && a<=x<=b */
int my_rand(int a, int b)
{
	assert(b >= a);
	return a + (int) ((double)(b-a+1)*rand()/(RAND_MAX+1.0));
}

int my_listen(const char* portnum)
{
	struct sockaddr_in adres;
	int port;
	char* endptr;
	int sockfd;
	port = strtol(portnum, &endptr, 0);
	if (!*portnum || *endptr) my_die("strtol");
	
	adres.sin_family = AF_INET;
	adres.sin_port = htons(port);
	adres.sin_addr.s_addr = INADDR_ANY;
	
	sockfd = socket(PF_INET, SOCK_STREAM, 0);
	if (sockfd == -1) my_die("socket");
	/*XXX sockfd must have O_NONBLOCK XXX*/

	if (bind(sockfd, (struct sockaddr*)&adres, sizeof(adres) ) == -1) my_die("bind");

	if (listen(sockfd, 100) == -1) my_die("listen");
	return sockfd;
}

int my_select(int n, fd_set* r, fd_set* w, fd_set* e, struct timeval* tv)
{
	int retval = select(n, r, w, e, tv);
	if (retval == -1) my_die("select");
	return retval;
}


